# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free
%define namedversion    0.9.11-SNAPSHOT
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           ops4j-pax-reflector
Summary:        Pax Reflector application inspection tool
Url:            http://team.ops4j.org/wiki/display/ops4j/Pax+Reflector
Version:        0.9.11
Release:        2%{?dist}
Epoch:          0
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-pax-reflector-0.9.11.tgz
# svn export https://scm.ops4j.org/repos/ops4j/projects/pax/reflector/ ops4j-pax-reflector-0.9.11
# tar czf ../SOURCES/ops4j-pax-reflector-0.9.11.tgz ops4j-pax-reflector-0.9.11/
 
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-bundle-plugin
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  easymock2
BuildRequires:  junit

BuildRequires:  org.osgi.core
BuildRequires:  org.osgi.compendium


Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  org.osgi.core
Requires:  org.osgi.compendium

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
The Pax Reflector is a application inspection tool, which 
can look into your running application without any special 
debugger. Although Pax Reflector can quite easily be used in 
any application, its use in OSGi environments make it even 
more powerful as it can be installed after the start of the 
main application and yet do the inspection. This could be 
very important when a faulty condition has occured and one 
need to take a closer look but can't restart the application 
with the debugger interface enabled.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax reflector %{namedversion} JPP/%{name} reflector
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-reflector.pom

install -m 644 api/target/pax-reflector-api-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/api-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-api %{namedversion} JPP/%{name} api
install -m 644 api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-api.pom

install -m 644 html/target/pax-reflector-html-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/html-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-html %{namedversion} JPP/%{name} html
install -m 644 html/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-html.pom

install -m 644 impl/target/pax-reflector-impl-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/impl-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-impl %{namedversion} JPP/%{name} impl
install -m 644 impl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-impl.pom

install -m 644 osgi/target/pax-reflector-service-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/service-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-service %{namedversion} JPP/%{name} service
install -m 644 osgi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-service.pom

install -m 644 servlet/target/pax-reflector-servlet-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/servlet-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-servlet %{namedversion} JPP/%{name} servlet
install -m 644 servlet/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-servlet.pom

install -m 644 spi/target/pax-reflector-spi-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/spi-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-spi %{namedversion} JPP/%{name} spi
install -m 644 spi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-spi.pom

install -m 644 typehandlers/target/pax-reflector-types-%{namedversion}.jar \
        $RPM_BUILD_ROOT%{_javadir}/%{name}/types-%{version}.jar
%add_to_maven_depmap org.ops4j.pax.reflector pax-reflector-types %{namedversion} JPP/%{name} types
install -m 644 typehandlers/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-types.pom

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Wed Sep 19 2012 Ralph Apel <r.apel at r-apel.de> 0:0.9.11-2
- 0.9.11 standalone

